/*
  ZynAddSubFX - a software synthesizer

  WidgetPDial.h - Fl_Dial Custom Behavior
  Copyright (C) 2016 Mark McCurry

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
*/
// generated by Fast Light User Interface Designer (fluid) version 1.0107f

#ifndef WIDGETPDIAL_h
#define WIDGETPDIAL_h
#include <FL/Fl_Dial.H>
#include "TipWin.h"


class WidgetPDial:public Fl_Dial
{
    public:
        WidgetPDial(int x, int y, int w, int h, const char *label = 0);
        ~WidgetPDial();
        int handle(int event);
        void draw();
        void pdialcolor(int r, int g, int b);
        void tooltip(const char *c);
	void set_transform(float (*transformer)(float));
        void set_rounding(unsigned int digits = 0);
        float reset_value;
    protected:
        bool integer_step;
        bool use_rounding;
    private:
        void getPos();
        void resetPos();
        double oldvalue;
        int old_y;
        bool   pos;
        bool   textset;
        class TipWin * tipwin;
        float (*transform)(float);
        int mod_state;
};
#endif
